import type { HideErrorPropType, IdPropType, InputTypeOnDefault, KoliBriHorizontalIcons, LabelWithExpertSlotPropType, MsgPropType, NamePropType, ComboboxAPI, ComboboxStates, Stringified, SyncValueBySelectorPropType, TooltipAlignPropType, SuggestionsPropType } from '../../schema';
import type { JSX } from '../../stencil-public-runtime';
export declare class KolCombobox implements ComboboxAPI {
    private readonly host?;
    private ref?;
    private refSuggestions;
    private _focusedOptionIndex;
    getValue(): Promise<string | undefined>;
    private toggleListbox;
    private readonly catchRef;
    private selectOption;
    private onInput;
    private handleKeyDownDropdown;
    private setFilteredSuggestionsByQuery;
    private moveFocus;
    private focusOption;
    private focusSuggestionStartingWith;
    render(): JSX.Element;
    handleKeyDown(event: KeyboardEvent): void;
    private readonly controller;
    private _isOpen;
    private _filteredSuggestions?;
    handleWindowClick(event: MouseEvent): void;
    _accessKey?: string;
    _placeholder?: string;
    _alert?: boolean;
    _disabled?: boolean;
    _hideError?: boolean;
    _hideLabel?: boolean;
    _hint?: string;
    _icons?: Stringified<KoliBriHorizontalIcons>;
    _id?: IdPropType;
    _label: LabelWithExpertSlotPropType;
    _msg?: MsgPropType;
    _name?: NamePropType;
    _on?: InputTypeOnDefault;
    _suggestions: string[];
    _required?: boolean;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _tabIndex?: number;
    _tooltipAlign?: TooltipAlignPropType;
    _touched?: boolean;
    _value?: string;
    state: ComboboxStates;
    constructor();
    validatePlaceholder(value?: string): void;
    validateAccessKey(value?: string): void;
    validateAlert(value?: boolean): void;
    validateDisabled(value?: boolean): void;
    validateHideError(value?: HideErrorPropType): void;
    validateHideLabel(value?: boolean): void;
    validateHint(value?: string): void;
    validateIcons(value?: Stringified<KoliBriHorizontalIcons>): void;
    validateId(value?: string): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateMsg(value?: MsgPropType): void;
    validateName(value?: string): void;
    validateOn(value?: InputTypeOnDefault): void;
    validateSuggestions(value?: SuggestionsPropType): void;
    validateRequired(value?: boolean): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTabIndex(value?: number): void;
    validateTouched(value?: boolean): void;
    validateValue(value?: string): void;
    componentWillLoad(): void;
    private onChange;
}
