import type { Generic } from 'adopted-style-sheets';
import type { PropAdjustHeight, PropDisabled, PropHasCounter, PropHideError, PropHideLabel, PropId, PropLabelWithExpertSlot, PropMsg, PropName, PropReadOnly, PropRequired, PropRows, PropSyncValueBySelector, PropTouched } from '../props';
import type { InputTypeOnDefault, KoliBriHorizontalIcons } from '../types';
export declare const cssResizeOptions: readonly ["both", "horizontal", "vertical", "none"];
export type CSSResize = (typeof cssResizeOptions)[number];
type RequiredProps = PropLabelWithExpertSlot;
type OptionalProps = {
    accessKey: string;
    alert: boolean;
    error: string;
    hint: string;
    icons: KoliBriHorizontalIcons;
    maxLength: number;
    on: InputTypeOnDefault;
    placeholder: string;
    resize: CSSResize;
    tabIndex: number;
    value: string;
} & PropAdjustHeight & PropDisabled & PropHasCounter & PropHideError & PropHideLabel & PropMsg & PropName & PropReadOnly & PropRequired & PropRows & PropSyncValueBySelector & PropTouched;
type RequiredStates = {
    adjustHeight: boolean;
    currentLength: number;
    hasValue: boolean;
    resize: CSSResize;
} & PropId & PropAdjustHeight & PropHideError & PropLabelWithExpertSlot;
type OptionalStates = {
    accessKey: string;
    alert: boolean;
    error: string;
    hint: string;
    icons: KoliBriHorizontalIcons;
    maxLength: number;
    on: InputTypeOnDefault;
    placeholder: string;
    tabIndex: number;
    value: string;
} & PropDisabled & PropHasCounter & PropHideLabel & PropMsg & PropName & PropReadOnly & PropRequired & PropRows & PropTouched;
export type TextareaProps = Generic.Element.Members<RequiredProps, OptionalProps>;
export type TextareaStates = Generic.Element.Members<RequiredStates, OptionalStates>;
export type TextareaWatches = Generic.Element.Watchers<RequiredProps, OptionalProps>;
export type TextareaAPI = Generic.Element.ComponentApi<RequiredProps, OptionalProps, RequiredStates, OptionalStates>;
export {};
